zenilib: zenilib/jni/external/sdl/src/joystick/SDL_gamecontroller.c File Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Macros | Typedefs | Functions | Variables
SDL_gamecontroller.c File Reference
`#include "SDL_config.h"`
`#include "SDL_events.h"`
`#include "SDL_assert.h"`
`#include "SDL_sysjoystick.h"`
`#include "SDL_hints.h"`
`#include "SDL_gamecontrollerdb.h"`
`#include "../events/SDL_events_c.h"`

Go to the source code of this file.

## Macros

#define | ABS(_x) ((_x) < 0 ? -(_x) : (_x))
#define | k_nMaxHatEntries 0x3f + 1
#define | k_nMaxReverseEntries 20

## Typedefs

typedef struct _ControllerMapping_t | ControllerMapping_t

## Functions

int | SDL_GameControllerAddMapping (const char *mappingString)
void | SDL_GameControllerClose (SDL_GameController *gamecontroller)
int | SDL_GameControllerEventState (int state)
int | SDL_GameControllerEventWatcher (void *userdata, SDL_Event *event)
SDL_bool | SDL_GameControllerGetAttached (SDL_GameController *gamecontroller)
Sint16 | SDL_GameControllerGetAxis (SDL_GameController *gamecontroller, SDL_GameControllerAxis axis)
SDL_GameControllerAxis | SDL_GameControllerGetAxisFromString (const char *pchString)
SDL_GameControllerButtonBind | SDL_GameControllerGetBindForAxis (SDL_GameController *gamecontroller, SDL_GameControllerAxis axis)
SDL_GameControllerButtonBind | SDL_GameControllerGetBindForButton (SDL_GameController *gamecontroller, SDL_GameControllerButton button)
Uint8 | SDL_GameControllerGetButton (SDL_GameController *gamecontroller, SDL_GameControllerButton button)
SDL_GameControllerButton | SDL_GameControllerGetButtonFromString (const char *pchString)
SDL_Joystick * | SDL_GameControllerGetJoystick (SDL_GameController *gamecontroller)
const char * | SDL_GameControllerGetStringForAxis (SDL_GameControllerAxis axis)
const char * | SDL_GameControllerGetStringForButton (SDL_GameControllerButton axis)
int | SDL_GameControllerInit (void)
static void | SDL_GameControllerLoadHints ()
char * | SDL_GameControllerMapping (SDL_GameController *gamecontroller)
char * | SDL_GameControllerMappingForGUID (SDL_JoystickGUID guid)
const char * | SDL_GameControllerName (SDL_GameController *gamecontroller)
const char * | SDL_GameControllerNameForIndex (int device_index)
SDL_GameController * | SDL_GameControllerOpen (int device_index)
void | SDL_GameControllerQuit (void)
void | SDL_GameControllerUpdate (void)
SDL_bool | SDL_IsGameController (int device_index)
int | SDL_PrivateGameControllerAxis (SDL_GameController *gamecontroller, SDL_GameControllerAxis axis, Sint16 value)
int | SDL_PrivateGameControllerButton (SDL_GameController *gamecontroller, SDL_GameControllerButton button, Uint8 state)
void | SDL_PrivateGameControllerParseButton (const char *szGameButton, const char *szJoystickButton, struct _SDL_ControllerMapping *pMapping)
static void | SDL_PrivateGameControllerParseControllerConfigString (struct _SDL_ControllerMapping *pMapping, const char *pchString)
void | SDL_PrivateGameControllerRefreshMapping (ControllerMapping_t *pControllerMapping)
char * | SDL_PrivateGetControllerGUIDFromMappingString (const char *pMapping)
ControllerMapping_t * | SDL_PrivateGetControllerMapping (int device_index)
ControllerMapping_t * | SDL_PrivateGetControllerMappingForGUID (SDL_JoystickGUID *guid)
char * | SDL_PrivateGetControllerMappingFromMappingString (const char *pMapping)
char * | SDL_PrivateGetControllerNameFromMappingString (const char *pMapping)
void | SDL_PrivateLoadButtonMapping (struct _SDL_ControllerMapping *pMapping, SDL_JoystickGUID guid, const char *pchName, const char *pchMapping)

## Variables

static const char * | map_StringForControllerAxis []
static const char * | map_StringForControllerButton []
static ControllerMapping_t * | s_pSupportedControllers = NULL
static SDL_GameController * | SDL_gamecontrollers = NULL

## Macro Definition Documentation

#define ABS | ( |  | _x | ) | ((_x) < 0 ? -(_x) : (_x))

Definition at line 34 of file SDL_gamecontroller.c.

Referenced by SDL_BlendLine_ARGB8888(), SDL_BlendLine_RGB2(), SDL_BlendLine_RGB4(), SDL_BlendLine_RGB555(), SDL_BlendLine_RGB565(), SDL_BlendLine_RGB888(), SDL_BlendLine_RGBA4(), SDL_DrawLine1(), SDL_DrawLine2(), SDL_DrawLine4(), SDL_GameControllerEventWatcher(), and SDL_GameControllerGetButton().

#define k_nMaxHatEntries 0x3f + 1

We are encoding the "HAT" as 0xhm. where h == hat ID and m == mask MAX 4 hats supported

Definition at line 53 of file SDL_gamecontroller.c.

Referenced by SDL_PrivateLoadButtonMapping().

#define k_nMaxReverseEntries 20

Definition at line 47 of file SDL_gamecontroller.c.

Referenced by SDL_GameControllerEventWatcher(), SDL_PrivateGameControllerParseButton(), and SDL_PrivateLoadButtonMapping().

## Typedef Documentation

typedef struct _ControllerMapping_t ControllerMapping_t

## Function Documentation

int SDL_GameControllerAddMapping | ( | const char * | mappingString | ) |

To count the number of game controllers in the system for the following: int nJoysticks = SDL_NumJoysticks(); int nGameControllers = 0; for ( int i = 0; i < nJoysticks; i++ ) { if ( SDL_IsGameController(i) ) { nGameControllers++; } }

Using the SDL_HINT_GAMECONTROLLERCONFIG hint or the SDL_GameControllerAddMapping you can add support for controllers SDL is unaware of or cause an existing controller to have a different binding. The format is: guid,name,mappings

Where GUID is the string value from SDL_JoystickGetGUIDString(), name is the human readable string for the device and mappings are controller mappings to joystick ones. Under Windows there is a reserved GUID of "xinput" that covers any XInput devices. The mapping format for joystick is: bX - a joystick button, index X hX.Y - hat X with value Y aX - axis X of the joystick Buttons can be used as a controller axis and vice versa.

This string shows an example of a valid mapping for a controller "341a3608000000000000504944564944,Afterglow PS3 Controller,a:b1,b:b2,y:b3,x:b0,start:b9,guide:b12,back:b8,dpup:h0.1,dpleft:h0.8,dpdown:h0.4,dpright:h0.2,leftshoulder:b4,rightshoulder:b5,leftstick:b10,rightstick:b11,leftx:a0,lefty:a1,rightx:a2,righty:a3,lefttrigger:b6,righttrigger:b7", Add or update an existing mapping configuration

Returns
  1 if mapping is added, 0 if updated, -1 on error

Definition at line 662 of file SDL_gamecontroller.c.

References s_pSupportedControllers, SDL_FALSE, SDL_free(), SDL_JoystickGetGUIDFromString(), SDL_malloc(), SDL_OutOfMemory, SDL_PrivateGameControllerRefreshMapping(), SDL_PrivateGetControllerGUIDFromMappingString(), SDL_PrivateGetControllerMappingForGUID(), SDL_PrivateGetControllerMappingFromMappingString(), SDL_PrivateGetControllerNameFromMappingString(), SDL_strcasecmp(), and SDL_TRUE.

Referenced by SDL_GameControllerInit(), and SDL_GameControllerLoadHints().

void SDL_GameControllerClose | ( | SDL_GameController * | gamecontroller | ) |

Close a controller previously opened with SDL_GameControllerOpen().

Definition at line 1086 of file SDL_gamecontroller.c.

References NULL, SDL_free(), SDL_gamecontrollers, and SDL_JoystickClose().

Referenced by SDL_GameControllerQuit().

int SDL_GameControllerEventState | ( | int | state | ) |

Enable/disable controller event polling.

If controller events are disabled, you must call SDL_GameControllerUpdate() yourself and check the state of the controller when you want controller information.

The state can be one of SDL_QUERY, SDL_ENABLE or SDL_IGNORE.

Definition at line 1218 of file SDL_gamecontroller.c.

References i, SDL_arraysize, SDL_CONTROLLERAXISMOTION, SDL_CONTROLLERBUTTONDOWN, SDL_CONTROLLERBUTTONUP, SDL_CONTROLLERDEVICEADDED, SDL_CONTROLLERDEVICEREMAPPED, SDL_CONTROLLERDEVICEREMOVED, SDL_ENABLE, SDL_EventState(), SDL_IGNORE, and SDL_QUERY.

Referenced by Zeni::Controllers::enable().

int SDL_GameControllerEventWatcher | ( | void * | userdata,
|  | SDL_Event * | event
| ) |  |

Definition at line 111 of file SDL_gamecontroller.c.

References ABS, SDL_JoyAxisEvent::axis, SDL_JoyButtonEvent::button, SDL_Event::cdevice, SDL_JoyHatEvent::hat, SDL_Event::jaxis, SDL_Event::jbutton, SDL_Event::jdevice, SDL_Event::jhat, k_nMaxReverseEntries, SDL_CONTROLLER_AXIS_TRIGGERLEFT, SDL_CONTROLLER_AXIS_TRIGGERRIGHT, SDL_CONTROLLERDEVICEADDED, SDL_CONTROLLERDEVICEREMOVED, SDL_gamecontrollers, SDL_HAT_DOWN, SDL_HAT_LEFT, SDL_HAT_RIGHT, SDL_HAT_UP, SDL_IsGameController(), SDL_JOYAXISMOTION, SDL_JOYBUTTONDOWN, SDL_JOYBUTTONUP, SDL_JOYDEVICEADDED, SDL_JOYDEVICEREMOVED, SDL_JOYHATMOTION, SDL_PRESSED, SDL_PrivateGameControllerAxis(), SDL_PrivateGameControllerButton(), SDL_PushEvent(), SDL_RELEASED, SDL_JoyButtonEvent::state, SDL_Event::type, SDL_JoyAxisEvent::value, SDL_JoyAxisEvent::which, SDL_JoyHatEvent::which, SDL_JoyButtonEvent::which, SDL_JoyDeviceEvent::which, and SDL_ControllerDeviceEvent::which.

Referenced by SDL_GameControllerInit(), and SDL_GameControllerQuit().

SDL_bool SDL_GameControllerGetAttached | ( | SDL_GameController * | gamecontroller | ) |

Returns SDL_TRUE if the controller has been opened and currently connected, or SDL_FALSE if it has not.

Definition at line 991 of file SDL_gamecontroller.c.

References SDL_FALSE, and SDL_JoystickGetAttached().

Referenced by Zeni::Controllers::is_controller_connected().

Sint16 SDL_GameControllerGetAxis | ( | SDL_GameController * | gamecontroller,
|  | SDL_GameControllerAxis | axis
| ) |  |

Get the current state of an axis control on a game controller.

The state is a value ranging from -32768 to 32767.

The axis indices start at index 0.

Definition at line 921 of file SDL_gamecontroller.c.

References SDL_CONTROLLER_AXIS_TRIGGERLEFT, SDL_CONTROLLER_AXIS_TRIGGERRIGHT, SDL_JoystickGetAxis(), and SDL_JoystickGetButton().

SDL_GameControllerAxis SDL_GameControllerGetAxisFromString | ( | const char * | pchString | ) |

turn this string into a axis mapping

Definition at line 309 of file SDL_gamecontroller.c.

References map_StringForControllerAxis, SDL_CONTROLLER_AXIS_INVALID, and SDL_strcasecmp().

Referenced by SDL_PrivateGameControllerParseButton().

SDL_GameControllerButtonBind SDL_GameControllerGetBindForAxis | ( | SDL_GameController * | gamecontroller,
|  | SDL_GameControllerAxis | axis
| ) |  |

Get the SDL joystick layer binding for this controller axis mapping

Definition at line 1027 of file SDL_gamecontroller.c.

References SDL_GameControllerButtonBind::bindType, SDL_GameControllerButtonBind::button, SDL_CONTROLLER_AXIS_INVALID, SDL_CONTROLLER_BINDTYPE_AXIS, SDL_CONTROLLER_BINDTYPE_BUTTON, SDL_memset(), and SDL_GameControllerButtonBind::value.

SDL_GameControllerButtonBind SDL_GameControllerGetBindForButton | ( | SDL_GameController * | gamecontroller,
|  | SDL_GameControllerButton | button
| ) |  |

Get the SDL joystick layer binding for this controller button mapping

Definition at line 1053 of file SDL_gamecontroller.c.

References SDL_GameControllerButtonBind::axis, SDL_GameControllerButtonBind::bindType, SDL_GameControllerButtonBind::button, SDL_GameControllerButtonBind::hat, SDL_CONTROLLER_BINDTYPE_AXIS, SDL_CONTROLLER_BINDTYPE_BUTTON, SDL_CONTROLLER_BINDTYPE_HAT, SDL_CONTROLLER_BUTTON_INVALID, SDL_memset(), and SDL_GameControllerButtonBind::value.

Uint8 SDL_GameControllerGetButton | ( | SDL_GameController * | gamecontroller,
|  | SDL_GameControllerButton | button
| ) |  |

Get the current state of a button on a game controller.

The button indices start at index 0.

Definition at line 956 of file SDL_gamecontroller.c.

References ABS, SDL_JoystickGetAxis(), SDL_JoystickGetButton(), and SDL_JoystickGetHat().

SDL_GameControllerButton SDL_GameControllerGetButtonFromString | ( | const char * | pchString | ) |

turn this string into a button mapping

Definition at line 357 of file SDL_gamecontroller.c.

References map_StringForControllerButton, SDL_CONTROLLER_BUTTON_INVALID, and SDL_strcasecmp().

Referenced by SDL_PrivateGameControllerParseButton().

SDL_Joystick* SDL_GameControllerGetJoystick | ( | SDL_GameController * | gamecontroller | ) |

Get the underlying joystick object used by a controller

Definition at line 1016 of file SDL_gamecontroller.c.

References NULL.

const char* SDL_GameControllerGetStringForAxis | ( | SDL_GameControllerAxis | axis | ) |

turn this axis enum into a string mapping

Definition at line 326 of file SDL_gamecontroller.c.

References map_StringForControllerAxis, NULL, SDL_CONTROLLER_AXIS_INVALID, and SDL_CONTROLLER_AXIS_MAX.

const char* SDL_GameControllerGetStringForButton | ( | SDL_GameControllerButton | button | ) |

turn this button enum into a string mapping

Definition at line 374 of file SDL_gamecontroller.c.

References map_StringForControllerButton, NULL, SDL_CONTROLLER_BUTTON_INVALID, and SDL_CONTROLLER_BUTTON_MAX.

int SDL_GameControllerInit | ( | void |  | ) |

Definition at line 787 of file SDL_gamecontroller.c.

References i, NULL, s_ControllerMappings, s_pSupportedControllers, SDL_AddEventWatch(), SDL_GameControllerAddMapping(), SDL_GameControllerEventWatcher(), and SDL_GameControllerLoadHints().

Referenced by SDL_InitSubSystem().

static void SDL_GameControllerLoadHints | ( |  | ) |

static

Definition at line 757 of file SDL_gamecontroller.c.

References NULL, SDL_free(), SDL_GameControllerAddMapping(), SDL_GetHint(), SDL_HINT_GAMECONTROLLERCONFIG, SDL_malloc(), SDL_memcpy(), SDL_strchr(), and SDL_strlen().

Referenced by SDL_GameControllerInit().

char* SDL_GameControllerMapping | ( | SDL_GameController * | gamecontroller | ) |

Get a mapping string for an open GameController

Returns
  the mapping string. Must be freed with SDL_free. Returns NULL if no mapping is available

Definition at line 751 of file SDL_gamecontroller.c.

References SDL_GameControllerMappingForGUID().

Referenced by Zeni::Controllers::device_added().

char* SDL_GameControllerMappingForGUID | ( | SDL_JoystickGUID | guid | ) |

Get a mapping string for a GUID

Returns
  the mapping string. Must be freed with SDL_free. Returns NULL if no mapping is available

Definition at line 731 of file SDL_gamecontroller.c.

References NULL, SDL_JoystickGetGUIDString(), SDL_malloc(), SDL_PrivateGetControllerMappingForGUID(), SDL_snprintf(), and SDL_strlen().

Referenced by SDL_GameControllerMapping().

const char* SDL_GameControllerName | ( | SDL_GameController * | gamecontroller | ) |

Return the name for this currently opened controller

Definition at line 1004 of file SDL_gamecontroller.c.

References NULL.

const char* SDL_GameControllerNameForIndex | ( | int | joystick_index | ) |

Get the implementation dependent name of a game controller. This can be called before any controllers are opened. If no name can be found, this function returns NULL.

Definition at line 815 of file SDL_gamecontroller.c.

References NULL, and SDL_PrivateGetControllerMapping().

SDL_GameController* SDL_GameControllerOpen | ( | int | joystick_index | ) |

Open a game controller for use. The index passed as an argument refers to the N'th game controller on the system. This index is the value which will identify this controller in future controller events.

Returns
  A controller identifier, or NULL if an error occurred.

Definition at line 849 of file SDL_gamecontroller.c.

References NULL, SDL_free(), SDL_gamecontrollers, SDL_JoystickOpen(), SDL_malloc(), SDL_memset(), SDL_NumJoysticks(), SDL_OutOfMemory, SDL_PrivateGetControllerMapping(), SDL_PrivateLoadButtonMapping(), SDL_SetError(), SDL_SYS_GetInstanceIdOfDeviceIndex(), and SDL_SYS_JoystickUpdate().

Referenced by Zeni::Controllers::device_added().

void SDL_GameControllerQuit | ( | void |  | ) |

Definition at line 1130 of file SDL_gamecontroller.c.

References NULL, s_pSupportedControllers, SDL_DelEventWatch(), SDL_free(), SDL_GameControllerClose(), SDL_GameControllerEventWatcher(), and SDL_gamecontrollers.

Referenced by SDL_QuitSubSystem().

void SDL_GameControllerUpdate | ( | void |  | ) |

Update the current state of the open game controllers.

This is called automatically by the event loop if any game controller events are enabled.

Definition at line 910 of file SDL_gamecontroller.c.

References SDL_JoystickUpdate().

SDL_bool SDL_IsGameController | ( | int | joystick_index | ) |

Is the joystick on this index supported by the game controller interface?

Definition at line 830 of file SDL_gamecontroller.c.

References SDL_FALSE, SDL_PrivateGetControllerMapping(), and SDL_TRUE.

Referenced by Zeni::Controllers::device_added(), and SDL_GameControllerEventWatcher().

int SDL_PrivateGameControllerAxis | ( | SDL_GameController * | gamecontroller,
|  | SDL_GameControllerAxis | axis,
|  | Sint16 | value
| ) |  |

Definition at line 1155 of file SDL_gamecontroller.c.

References SDL_CONTROLLERAXISMOTION, SDL_ENABLE, SDL_GetEventState, and SDL_PushEvent().

Referenced by SDL_GameControllerEventWatcher().

int SDL_PrivateGameControllerButton | ( | SDL_GameController * | gamecontroller,
|  | SDL_GameControllerButton | button,
|  | Uint8 | state
| ) |  |

Definition at line 1179 of file SDL_gamecontroller.c.

References SDL_CONTROLLER_BUTTON_INVALID, SDL_CONTROLLERBUTTONDOWN, SDL_CONTROLLERBUTTONUP, SDL_ENABLE, SDL_GetEventState, SDL_PRESSED, SDL_PushEvent(), SDL_RELEASED, and SDL_Event::type.

Referenced by SDL_GameControllerEventWatcher().

void SDL_PrivateGameControllerParseButton | ( | const char * | szGameButton,
|  | const char * | szJoystickButton,
|  | struct _SDL_ControllerMapping * | pMapping
| ) |  |

Definition at line 386 of file SDL_gamecontroller.c.

References k_nMaxReverseEntries, SDL_assert, SDL_atoi(), SDL_CONTROLLER_AXIS_INVALID, SDL_CONTROLLER_BUTTON_INVALID, SDL_GameControllerGetAxisFromString(), SDL_GameControllerGetButtonFromString(), and SDL_SetError().

Referenced by SDL_PrivateGameControllerParseControllerConfigString().

static void SDL_PrivateGameControllerParseControllerConfigString | ( | struct _SDL_ControllerMapping * | pMapping,
|  | const char * | pchString
| ) |  |

static

Definition at line 472 of file SDL_gamecontroller.c.

References i, SDL_FALSE, SDL_memset(), SDL_PrivateGameControllerParseButton(), SDL_SetError(), and SDL_TRUE.

Referenced by SDL_PrivateLoadButtonMapping().

void SDL_PrivateGameControllerRefreshMapping | ( | ControllerMapping_t * | pControllerMapping | ) |

Definition at line 638 of file SDL_gamecontroller.c.

References SDL_CONTROLLERDEVICEREMAPPED, SDL_gamecontrollers, SDL_memcmp(), SDL_PrivateLoadButtonMapping(), and SDL_PushEvent().

Referenced by SDL_GameControllerAddMapping().

char* SDL_PrivateGetControllerGUIDFromMappingString | ( | const char * | pMapping | ) |

Definition at line 573 of file SDL_gamecontroller.c.

References NULL, SDL_malloc(), SDL_memcpy(), SDL_OutOfMemory, and SDL_strchr().

Referenced by SDL_GameControllerAddMapping().

ControllerMapping_t* SDL_PrivateGetControllerMapping | ( | int | device_index | ) |

Definition at line 279 of file SDL_gamecontroller.c.

References NULL, SDL_JoystickGetDeviceGUID(), and SDL_PrivateGetControllerMappingForGUID().

Referenced by SDL_GameControllerNameForIndex(), SDL_GameControllerOpen(), and SDL_IsGameController().

ControllerMapping_t* SDL_PrivateGetControllerMappingForGUID | ( | SDL_JoystickGUID * | guid | ) |

Definition at line 262 of file SDL_gamecontroller.c.

References NULL, s_pSupportedControllers, and SDL_memcmp().

Referenced by SDL_GameControllerAddMapping(), SDL_GameControllerMappingForGUID(), and SDL_PrivateGetControllerMapping().

char* SDL_PrivateGetControllerMappingFromMappingString | ( | const char * | pMapping | ) |

Definition at line 623 of file SDL_gamecontroller.c.

References NULL, SDL_strchr(), and SDL_strdup().

Referenced by SDL_GameControllerAddMapping().

char* SDL_PrivateGetControllerNameFromMappingString | ( | const char * | pMapping | ) |

Definition at line 595 of file SDL_gamecontroller.c.

References NULL, SDL_malloc(), SDL_memcpy(), SDL_OutOfMemory, and SDL_strchr().

Referenced by SDL_GameControllerAddMapping().

void SDL_PrivateLoadButtonMapping | ( | struct _SDL_ControllerMapping * | pMapping,
|  | SDL_JoystickGUID | guid,
|  | const char * | pchName,
|  | const char * | pchMapping
| ) |  |

Definition at line 533 of file SDL_gamecontroller.c.

References j, k_nMaxHatEntries, k_nMaxReverseEntries, SDL_CONTROLLER_AXIS_INVALID, SDL_CONTROLLER_AXIS_MAX, SDL_CONTROLLER_BUTTON_INVALID, SDL_CONTROLLER_BUTTON_MAX, and SDL_PrivateGameControllerParseControllerConfigString().

Referenced by SDL_GameControllerOpen(), and SDL_PrivateGameControllerRefreshMapping().

## Variable Documentation

const char* map_StringForControllerAxis[]

static

Initial value:
= {
"leftx",
"lefty",
"rightx",
"righty",
"lefttrigger",
"righttrigger",
NULL
}
NULL
#define NULL
Definition: ftobjs.h:61

Definition at line 296 of file SDL_gamecontroller.c.

Referenced by SDL_GameControllerGetAxisFromString(), and SDL_GameControllerGetStringForAxis().

const char* map_StringForControllerButton[]

static

Initial value:
= {
"a",
"b",
"x",
"y",
"back",
"guide",
"start",
"leftstick",
"rightstick",
"leftshoulder",
"rightshoulder",
"dpup",
"dpdown",
"dpleft",
"dpright",
NULL
}
NULL
#define NULL
Definition: ftobjs.h:61

Definition at line 335 of file SDL_gamecontroller.c.

Referenced by SDL_GameControllerGetButtonFromString(), and SDL_GameControllerGetStringForButton().

ControllerMapping_t* s_pSupportedControllers = NULL

static

Definition at line 89 of file SDL_gamecontroller.c.

Referenced by SDL_GameControllerAddMapping(), SDL_GameControllerInit(), SDL_GameControllerQuit(), and SDL_PrivateGetControllerMappingForGUID().

SDL_GameController* SDL_gamecontrollers = NULL

static

Definition at line 38 of file SDL_gamecontroller.c.

Referenced by SDL_GameControllerClose(), SDL_GameControllerEventWatcher(), SDL_GameControllerOpen(), SDL_GameControllerQuit(), and SDL_PrivateGameControllerRefreshMapping().